import pygame, data, os
from constants import *

class graphics:
	def __init__(self):
		self.images = {} # this dictionary will hold the objects
		pygame.init()
		self.screen = pygame.display.set_mode(windowSize)
		pygame.display.set_caption('Lunar Delivery')
		self.fonts = {}
		self.fonts["info"] = pygame.font.Font(font_dir+'/Vera.ttf', 10)
		self.fonts["big"] = pygame.font.Font(font_dir+'/Vera.ttf', 30)
		
	def load(self, filename, name, trans=False, transcolor=(255,255,255)):
		self.images[name] = pygame.image.load(os.path.join(data_dir, filename)).convert()
		if trans:
			self.images[name].set_colorkey(transcolor)
			
	def fill(self, color):
		self.screen.fill(color)
		
	def draw(self, name, pos):
		self.screen.blit(self.images[name], pos)
	
	def drawline(self, pos, pos2, width=1):
		pygame.draw.aaline(self.screen, stringColor, pos, pos2, width)
	
	def finalise(self):
		pygame.display.flip()
	
	def gettick(self):
		return pygame.time.get_ticks()
		
	def drawpoly(self, vertlist, color, edge=False):
		pygame.draw.polygon(self.screen, color, vertlist, edge)
		
	def write(self, fontname, text, pos, color=(0,0,0), centered=True, AA=True):
		font = self.fonts[fontname]
		a = font.render(text,AA,color)
		if centered == False:
			self.screen.blit(a,pos)
		else:
			size = a.get_size()
			d = (pos[0]-size[0]/2, pos[1]-size[1]/2)
			self.screen.blit(a,d)
	def drawrect(self, color, rect):
		pygame.draw.rect(self.screen,color, rect)
