'''note this file isn't used anymore, it has been replaced by verletropephysics
but if you want an example of euler integration failing to create a good stable
rope then here it is '''


import math, graphicsclass
from constants import *

def getleng(a, b):
	return math.sqrt((a[0] - b[0])**2 + (a[1] + b[1])**2)

class Mass:
	"""Basic point mass"""
	def __init__(self, m, x, y):
		self.m = m
		self.pos = [x, y]
		self.force = [0, 0]
		self.velocity = [0, 0]
	def applyforce(self, a_force):
		self.force[0] += a_force[0]
		self.force[1] += a_force[1]
	def simulate(self, dt):
		self.velocity[0] += (self.force[0] / self.m) * dt
		self.velocity[1] += (self.force[1] / self.m) * dt
		self.pos[0] += self.velocity[0] * dt
		self.pos[1] += self.velocity[1] * dt

class Spring:
	"""spring object"""
	def __init__(self, mass1, mass2, springconst, springlen, frictionconst):
		self.mass1 = mass1
		self.mass2 = mass2
		self.springconst = springconst
		self.springlen = springlen
		self.frictionconst = frictionconst
	def solve(self):
		a = getleng(self.mass1.pos, self.mass2.pos)
		
		
		
		vect = [self.mass1.pos[0] - self.mass2.pos[0],self.mass1.pos[1] - self.mass2.pos[1]]
		r = getleng(vect, (0,0)) # math.sqrt(vect[0]^2 + vect[1]^2)
	
		force = [0,0]
		if r <> 0:
			force[0] += -(vect[0] / r) * (r - self.springlen) * self.springconst
			force[1] += -(vect[1] / r) * (r - self.springlen) * self.springconst
			#print force
			
			#now apply some friction
			force[0] += -(self.mass1.velocity[0] - self.mass2.velocity[0]) * self.frictionconst
			force[1] += -(self.mass1.velocity[1] - self.mass2.velocity[1]) * self.frictionconst
			#print force
		
			self.mass1.applyforce(force)
			self.mass2.applyforce((-force[0],-force[1]))
			
class Rope:
	"""uh oh, rope time"""
	def __init__(self, startpos, stoppos, m, nummasses, springconst, springfric, gravity, airfric):
		leng = getleng(startpos, stoppos)
		print(leng)
		springleng = float(leng)/float(nummasses-1) #  get the actual value for the length of each spring (-1 because we've got a mass on each end)
		print(springleng)
		addval = [(float(stoppos[0] - startpos[0])/float(nummasses-1)), (float(stoppos[1] - startpos[1])/float(nummasses-1))]
		print(addval)
		self.masses = []
		for each in range(nummasses):
			self.masses.append(Mass(m, startpos[0] + addval[0] * each, startpos[1] + addval[1] * each))
		#print(self.masses)
		self.springs = []
		for each in range(nummasses-1):
			self.springs.append(Spring(self.masses[each], self.masses[each+1], springconst, springleng, springfric));
		
		#print(self.springs)
		self.gravity = gravity
		self.airfric = airfric
	
	def solve(self):
		for spring in self.springs:
			spring.solve()
		for mass in self.masses:
			#pass
			mass.applyforce(((self.gravity[0] * mass.m),(self.gravity[1] * mass.m)))
			mass.applyforce(((-mass.velocity[0] * self.airfric), (-mass.velocity[1] * self.airfric)))
	
	def simulate(self, dt):
		self.solve()	#solve the forces
		for i in range(1,len(self.masses)):
			self.masses[i].simulate(dt)	#simulate the masses
		for each in self.masses:
			each.force = [0,0]
			
	def draw(self, graphics):
		for i in range(len(self.masses)-1):
			graphics.drawline(self.masses[i].pos,self.masses[i+1].pos);
