import graphicsclass, inputclass, soundclass
from constants import *

class playership:
	def __init__(self, x, y, gravity, graphics, input, world):
		
		graphics.load("ship.bmp","ship", True, [0,0,0])
		graphics.load("blastmiddle.bmp","mainblast", True, [0,0,0])
		graphics.load("blastleft.bmp","leftblast", True, [0,0,0])
		graphics.load("blastright.bmp","rightblast", True, [0,0,0])
		graphics.load("explode1.bmp","explode1", True, [0,0,0])
		graphics.load("explode2.bmp","explode2", True, [0,0,0])
		graphics.load("explode3.bmp","explode3", True, [0,0,0])
		self.pos = [x, y]
		self.oldpos = [x, y]
		self.vel = [0, 0]
		self.gravity = gravity
		self.graphics = graphics
		self.inputs = input
		self.world = world
		self.strength = 100
		self.maxstrength = self.strength
		self.fuel = 100
		self.maxfuel = 100
		self.startanim = None
		
	def setpos(self, pos):
		self.oldpos = self.pos
		self.pos = pos
	
	def collision(self):
		result = None
		if self.pos[1] > windowSize[1]:
			result = (self.pos[0],windowSize[1])
			self.vel[1] = -self.vel[1]*0.3
			
		if self.pos[1] < self.world.checkceil(self.pos[0])+45:
			a = self.world.GetCeilProjection((self.pos[0],self.pos[1]-45))
			result = (1,(a[0],a[1]+45))
		
		if self.pos[1] < self.world.checkceil(self.pos[0]+50)+25:
			a = self.world.GetCeilProjection((self.pos[0]+50,self.pos[1]-25))
			result = (1,(a[0]-50,a[1]+25))			

		if self.pos[1] < self.world.checkceil(self.pos[0]-50)+25:
			a = self.world.GetCeilProjection((self.pos[0]-50,self.pos[1]-25))
			result = (1,(a[0]+50,a[1]+25))

		if self.pos[1] < self.world.checkceil(self.pos[0]+35)+35:
			a = self.world.GetCeilProjection((self.pos[0]+35,self.pos[1]-35))
			result = (1,(a[0]-35,a[1]+35))			

		if self.pos[1] < self.world.checkceil(self.pos[0]-35)+35:
			a = self.world.GetCeilProjection((self.pos[0]-35,self.pos[1]-35))
			result = (1,(a[0]+35,a[1]+35))
			
		if self.pos[1]> self.world.checkfloor(self.pos[0])-32:
			a = self.world.getprojection((self.pos[0],self.pos[1]+32))
			result = (0,(a[0],a[1]-32))
		return result
		
	def draw(self, string, acc, sounds):
		#x = string.oldparticles[0][0] + (string.particles[0][0] - string.oldparticles[0][0]) * acc/timeStep - 75
		x = halfwindowsize[0]-75
		y = string.oldparticles[0][1] + (string.particles[0][1] - string.oldparticles[0][1]) * acc/timeStep - 75
		p = (x,y)
		if self.strength > 0:
			dosound = False
			if self.inputs.keys["up"] == True and self.fuel > 0:
				dosound = True
				self.graphics.draw("mainblast", p)
				
				
			if self.inputs.keys["left"] == True and self.fuel > 0:
				dosound = True
				self.graphics.draw("rightblast", p)

				
			if self.inputs.keys["right"] == True and self.fuel > 0:
				dosound = True
				self.graphics.draw("leftblast", p)
			
				
			if dosound == True:
				if self.doingthrust == False:
					sounds.play('thrust',-1)
					self.doingthrust = True
			else:
				sounds.stop('thrust')
				self.doingthrust = False
				
			self.graphics.draw("ship", p)
		else:
			if self.startanim == None:
				self.startanim = self.graphics.gettick()
				sounds.play('explode')
			new = self.graphics.gettick()
			t = new - self.startanim	#t = how long since we started playing the animation(in ms)
			t = t / 100	#in deciseconds (our desired frame rate)
			if t == 0:
				self.graphics.draw("explode1", p)
			if t == 1:
				self.graphics.draw("explode2", p)
			if t == 3:
				self.graphics.draw("explode3", p)
			if t == 4:
				self.graphics.draw("explode1", p)
			if t == 5:
				self.graphics.draw("explode2", p)
			if t == 6:
				self.graphics.draw("explode3", p)
			if t == 7:
				return 1
		return 0
		
	def go(self, dt):		#this isn't used anymore
		acc = [0, self.gravity]
		self.vel[0] += acc[0] * dt
		self.vel[1] += acc[1] * dt
		self.pos[0] += self.vel[0] * dt
		self.pos[1] += self.vel[1] * dt
		if self.pos[0] > windowSize[0]:
			self.pos[0] = windowSize[0]
			self.vel[0] = -self.vel[0]*0.3
		if self.pos[0] < 0:
			self.pos[0] = 0
			self.vel[0] = -self.vel[0]*0.3
		if self.pos[1] > windowSize[1]:
			self.pos[1] = windowSize[1]
			self.vel[1] = -self.vel[1]*0.3
		if self.pos[1] < 0:
			self.pos[1] = 0
			self.vel[1] = -self.vel[1]*0.3
	